Codeforces 1051D Bicolorings
You are given a grid, consisting of 2 rows and n columns. Each cell of this grid should be colored either black or white.
Two cells are considered neighbours if they have a common border and share the same color. Two cells A and B belong to the same component if they are neighbours, or if there is a neighbour of A that belongs to the same component with B.
Let's call some bicoloring beautiful if it has exactly k components.
Count the number of beautiful bicolorings. The number can be big enough, so print the answer modulo 998244353.
Input
The only line contains two integers n and k (1≤n≤1000, 1≤k≤2n) — the number of columns in a grid and the number of components required.
Output
Print a single integer — the number of beautiful bicolorings modulo 998244353.
Examples
Input
3 4
Output
12
Input
4 1
Output
2
Input
1 2
Output
2
Note
One of possible bicolorings in sample 1
題意:給你一個2*n的矩陣,你只能填黑塊或者是白塊使得把這個矩陣分成k個部分,問你有多少種方案數?
解題思路:我設一個dp
dp[i][j][ki] 表示的是我到第i列已經有k塊了 ki==1的表示第i列不是同一種顏色,ki==0表示第i列是同一種顏色
由於第i行的狀態只與第i-1行的狀態有關m,所以我們只需要考慮2*2的矩陣的情況就行
首先 我們就對一列進行考慮,
很容易知道 dp[1][1][0]=2,dp[1][2][1]=2, 其他狀態都為0
這時候我們考慮狀態轉移
2*2的矩陣中每一個格子可以選黑塊或者是白塊,所以有2*2*2*2=16種情況。
這四種為同一種情況 dp[i][j][0]+=2*dp[i-1][j][1];
這兩種算一種情況 dp[i][j][0]+=dp[i-1][k-1][0];
這也算一種情況 dp[i][j][0]+=dp[i-1][j][0];
同理 這也算一種情況
dp[i][j][1]+=2*dp[i-1][j-1][0];
這算一種情況,dp[i][j][1]+=dp[i-1][j][1];
最後一種情況
dp[i][j][1]+=dp[i-1][j-2][1];
然後暴力dp求解
#include<stdio.h>
#include<string.h>
#include<queue>
#include<algorithm>
using namespace std;
const int maxn=1100;
const long long mod=998244353;
#define ll long long
#define mem(a,b) memset(a,b,sizeof(a))
ll dp[maxn][2*maxn][2],n,m;
int main(){
int i,j;
mem(dp,0);
scanf("%I64d%I64d",&n,&m);
dp[1][2][1]=2;dp[1][1][0]=2;
for(i=2;i<=n;i++){
for(j=1;j<=m;j++){
dp[i][j][0]+=2*dp[i-1][j][1]+dp[i-1][j-1][0]+dp[i-1][j][0];
dp[i][j][0]%=mod;
dp[i][j][1]+=2*dp[i-1][j-1][0]+dp[i-1][j-2][1]+dp[i-1][j][1];
dp[i][j][1]%=mod;
}
}
ll ans=(dp[n][m][0]+dp[n][m][1])%mod;
printf("%I64d\n",ans);
return 0;
}